import{S as Ys,i as Gs,s as Js,e as l,k as m,w as g,t as n,M as Zs,c as i,d as t,m as u,a as p,x as _,h as r,b as h,G as o,g as a,y as w,q as x,o as k,B as $,v as ea,L as ta}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as Ws}from"../../../../chunks/Tip-hf-doc-builder.js";import{I as nt}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{C as F}from"../../../../chunks/CodeBlock-hf-doc-builder.js";function oa(Ee){let d,q,c,O,X;return{c(){d=l("p"),q=n(`Once exported, a model can be optimized for inference via techniques such as
graph optimization and quantization. Check the `),c=l("code"),O=n("optimum.onnxruntime"),X=n(" subpackage to optimize and run ONNX models!")},l(v){d=i(v,"P",{});var N=p(d);q=r(N,`Once exported, a model can be optimized for inference via techniques such as
graph optimization and quantization. Check the `),c=i(N,"CODE",{});var P=p(c);O=r(P,"optimum.onnxruntime"),P.forEach(t),X=r(N," subpackage to optimize and run ONNX models!"),N.forEach(t)},m(v,N){a(v,d,N),o(d,q),o(d,c),o(c,O),o(d,X)},d(v){v&&t(d)}}}function sa(Ee){let d,q,c,O,X,v,N,P,E,K,y,j,I,T,re,z,Q;return N=new F({props:{code:'model = ORTModelForQuestionAnswering.from_pretrained("distilbert-base-uncased-distilled-squad", from_transformers=True)',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased-distilled-squad&quot;</span>, from_transformers=<span class="hljs-literal">True</span>)'}}),{c(){d=l("p"),q=n("It is also possible to export the model to ONNX directly from the "),c=l("code"),O=n("ORTModelForQuestionAnswering"),X=n(" class by doing the following:"),v=m(),g(N.$$.fragment),P=m(),E=l("p"),K=n("For more information, check the "),y=l("code"),j=n("optimum.onnxrutime"),I=n(" documentation "),T=l("a"),re=n("page on this topic"),z=n("."),this.h()},l(f){d=i(f,"P",{});var b=p(d);q=r(b,"It is also possible to export the model to ONNX directly from the "),c=i(b,"CODE",{});var Te=p(c);O=r(Te,"ORTModelForQuestionAnswering"),Te.forEach(t),X=r(b," class by doing the following:"),b.forEach(t),v=u(f),_(N.$$.fragment,f),P=u(f),E=i(f,"P",{});var D=p(E);K=r(D,"For more information, check the "),y=i(D,"CODE",{});var M=p(y);j=r(M,"optimum.onnxrutime"),M.forEach(t),I=r(D," documentation "),T=i(D,"A",{href:!0});var le=p(T);re=r(le,"page on this topic"),le.forEach(t),z=r(D,"."),D.forEach(t),this.h()},h(){h(T,"href","/onnxruntime/overview")},m(f,b){a(f,d,b),o(d,q),o(d,c),o(c,O),o(d,X),a(f,v,b),w(N,f,b),a(f,P,b),a(f,E,b),o(E,K),o(E,y),o(y,j),o(E,I),o(E,T),o(T,re),o(E,z),Q=!0},p:ta,i(f){Q||(x(N.$$.fragment,f),Q=!0)},o(f){k(N.$$.fragment,f),Q=!1},d(f){f&&t(d),f&&t(v),$(N,f),f&&t(P),f&&t(E)}}}function aa(Ee){let d,q,c,O,X,v,N,P,E,K,y,j,I,T,re,z,Q,f,b,Te,D,M,le,Ae,oo,rt,ie,lt,H,B,Le,pe,so,Ke,ao,it,V,no,me,ro,lo,pt,U,io,Qe,po,mo,mt,Xe,uo,ut,W,ht,Pe,ho,dt,qe,ue,fo,je,co,go,ft,R,Y,Be,he,_o,Ve,wo,ct,Fe,xo,gt,de,_t,De,ko,wt,fe,xt,Me,$o,kt,ce,$t,Se,vo,vt,ge,Nt,G,No,Ue,bo,Oo,bt,J,yo,We,Eo,To,Ot,_e,yt,Z,Ao,Ye,Xo,Po,Et,A,qo,Ge,jo,Fo,we,Do,Mo,xe,So,Co,Je,Io,zo,Tt,ke,At,Ce,Ho,Xt,$e,Pt,Ie,Ro,qt,ee,jt,te,Lo,ve,Ko,Qo,Ft,Ne,Dt,L,oe,Ze,be,Bo,et,Vo,Mt,se,Uo,tt,Wo,Yo,St,ae,Go,ze,Jo,Zo,Ct,ne,es,He,ts,os,It,Oe,zt,S,ss,ot,as,ns,st,rs,ls,Ht;return v=new nt({}),T=new nt({}),M=new F({props:{code:"optimum-cli export onnx --model gpt2 gpt2_onnx/",highlighted:'<span class="hljs-title">optimum</span>-cli ex<span class="hljs-keyword">port</span> onnx <span class="hljs-comment">--model gpt2 gpt2_onnx/</span>'}}),ie=new F({props:{code:"optimum-cli export onnx --help",highlighted:'<span class="hljs-title">optimum</span>-cli ex<span class="hljs-keyword">port</span> onnx <span class="hljs-comment">--help</span>'}}),pe=new nt({}),W=new Ws({props:{$$slots:{default:[oa]},$$scope:{ctx:Ee}}}),he=new nt({}),de=new F({props:{code:"pip install optimum[exporters]",highlighted:"pip install optimum[exporters]"}}),fe=new F({props:{code:`optimum-cli export onnx --help

usage: Hugging Face Optimum ONNX exporter [-h] -m MODEL [--task TASK] [--opset OPSET] [--atol ATOL] [--framework {pt,tf}] [--pad_token_id PAD_TOKEN_ID] [--cache_dir CACHE_DIR] output

positional arguments:
  output                Path indicating the directory where to store generated ONNX model.

optional arguments:
  -h, --help            show this help message and exit
  -m MODEL, --model MODEL
                        Model ID on huggingface.co or path on disk to load model from.
  --task TASK           The type of task to export the model with.
  --opset OPSET         ONNX opset version to export the model with.
  --atol ATOL           Absolute difference tolerance when validating the model.
  --framework {pt,tf}   The framework to use for the ONNX export. If not provided, will attempt to use the local checkpoint's original framework or what is available in the environment.
  --pad_token_id PAD_TOKEN_ID
                        This is needed by some models, for some tasks. If not provided, will attempt to use the tokenizer to guess it.
  --cache_dir CACHE_DIR
                        Path indicating where to store cache.`,highlighted:`optimum-cli <span class="hljs-built_in">export</span> onnx --<span class="hljs-built_in">help</span>

usage: Hugging Face Optimum ONNX exporter [-h] -m MODEL [--task TASK] [--opset OPSET] [--atol ATOL] [--framework {pt,tf}] [--pad_token_id PAD_TOKEN_ID] [--cache_dir CACHE_DIR] output

positional arguments:
  output                Path indicating the directory <span class="hljs-built_in">where</span> to store generated ONNX model.

optional arguments:
  -h, --<span class="hljs-built_in">help</span>            show this <span class="hljs-built_in">help</span> message and <span class="hljs-built_in">exit</span>
  -m MODEL, --model MODEL
                        Model ID on huggingface.co or path on disk to load model from.
  --task TASK           The <span class="hljs-built_in">type</span> of task to <span class="hljs-built_in">export</span> the model with.
  --opset OPSET         ONNX opset version to <span class="hljs-built_in">export</span> the model with.
  --atol ATOL           Absolute difference tolerance when validating the model.
  --framework {pt,tf}   The framework to use <span class="hljs-keyword">for</span> the ONNX <span class="hljs-built_in">export</span>. If not provided, will attempt to use the <span class="hljs-built_in">local</span> checkpoint<span class="hljs-string">&#x27;s original framework or what is available in the environment.
  --pad_token_id PAD_TOKEN_ID
                        This is needed by some models, for some tasks. If not provided, will attempt to use the tokenizer to guess it.
  --cache_dir CACHE_DIR
                        Path indicating where to store cache.</span>`}}),ce=new F({props:{code:"optimum-cli export onnx --model distilbert-base-uncased-distilled-squad distilbert_base_uncased_squad_onnx/",highlighted:'optimum-cli <span class="hljs-built_in">export</span> onnx --model distilbert-base-uncased-distilled-squad distilbert_base_uncased_squad_onnx/'}}),ge=new F({props:{code:`Automatic task detection to question-answering.
Framework not specified. Using pt to export to ONNX.
Using framework PyTorch: 1.12.1

Validating ONNX model...
        -[\u2713] ONNX model output names match reference model (start_logits, end_logits)
        - Validating ONNX Model output "start_logits":
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
        - Validating ONNX Model output "end_logits":
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
All good, model saved at: distilbert_base_uncased_squad_onnx/model.onnx`,highlighted:`Automatic task detection to question-answering.
Framework not specified. Using pt to <span class="hljs-built_in">export</span> to ONNX.
Using framework PyTorch: 1.12.1

Validating ONNX model...
        -[\u2713] ONNX model output names match reference model (start_logits, end_logits)
        - Validating ONNX Model output <span class="hljs-string">&quot;start_logits&quot;</span>:
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
        - Validating ONNX Model output <span class="hljs-string">&quot;end_logits&quot;</span>:
                -[\u2713] (2, 16) matches (2, 16)
                -[\u2713] all values close (atol: 0.0001)
All good, model saved at: distilbert_base_uncased_squad_onnx/model.onnx`}}),_e=new F({props:{code:"optimum-cli export onnx --model local_path --task question-answering distilbert_base_uncased_squad_onnx/",highlighted:'optimum-cli <span class="hljs-built_in">export</span> onnx --model local_path --task question-answering distilbert_base_uncased_squad_onnx/'}}),ke=new F({props:{code:`from transformers import AutoTokenizer
from optimum.onnxruntime import ORTModelForQuestionAnswering

tokenizer = AutoTokenizer.from_pretrained("distilbert_base_uncased_squad_onnx")
model = ORTModelForQuestionAnswering.from_pretrained("distilbert_base_uncased_squad_onnx")

inputs = tokenizer("What am I using?", "Using DistilBERT with ONNX Runtime!", return_tensors="pt")
outputs = model(**inputs)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.onnxruntime <span class="hljs-keyword">import</span> ORTModelForQuestionAnswering

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;distilbert_base_uncased_squad_onnx&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = ORTModelForQuestionAnswering.from_pretrained(<span class="hljs-string">&quot;distilbert_base_uncased_squad_onnx&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(<span class="hljs-string">&quot;What am I using?&quot;</span>, <span class="hljs-string">&quot;Using DistilBERT with ONNX Runtime!&quot;</span>, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)`}}),$e=new F({props:{code:`QuestionAnsweringModelOutput(loss=None, start_logits=tensor([[-4.7652, -1.0452, -7.0409, -4.6864, -4.0277, -6.2021, -4.9473,  2.6287,
          7.6111, -1.2488, -2.0551, -0.9350,  4.9758, -0.7707,  2.1493, -2.0703,
         -4.3232, -4.9472]]), end_logits=tensor([[ 0.4382, -1.6502, -6.3654, -6.0661, -4.1482, -3.5779, -0.0774, -3.6168,
         -1.8750, -2.8910,  6.2582,  0.5425, -3.7699,  3.8232, -1.5073,  6.2311,
          3.3604, -0.0772]]), hidden_states=None, attentions=None)`,highlighted:`QuestionAnsweringModelOutput(loss=None, start_logits=tensor([[-4.7652, -1.0452, -7.0409, -4.6864, -4.0277, -6.2021, -4.9473,  2.6287,
          7.6111, -1.2488, -2.0551, -0.9350,  4.9758, -0.7707,  2.1493, -2.0703,
         -4.3232, -4.9472]]), end_logits=tensor([[ 0.4382, -1.6502, -6.3654, -6.0661, -4.1482, -3.5779, -0.0774, -3.6168,
         -1.8750, -2.8910,  6.2582,  0.5425, -3.7699,  3.8232, -1.5073,  6.2311,
          3.3604, -0.0772]]), hidden_states=None, attentions=None)`}}),ee=new Ws({props:{$$slots:{default:[sa]},$$scope:{ctx:Ee}}}),Ne=new F({props:{code:"optimum-cli export onnx --model keras-io/transformers-qa distilbert_base_cased_squad_onnx/",highlighted:'optimum-cli <span class="hljs-built_in">export</span> onnx --model keras-io/transformers-qa distilbert_base_cased_squad_onnx/'}}),be=new nt({}),Oe=new F({props:{code:`from optimum.exporters.tasks import TasksManager

distilbert_tasks = list(TasksManager.get_supported_tasks_for_model_type("distilbert", "onnx").keys())
print(distilbert_tasks)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> optimum.exporters.tasks <span class="hljs-keyword">import</span> TasksManager

<span class="hljs-meta">&gt;&gt;&gt; </span>distilbert_tasks = <span class="hljs-built_in">list</span>(TasksManager.get_supported_tasks_for_model_type(<span class="hljs-string">&quot;distilbert&quot;</span>, <span class="hljs-string">&quot;onnx&quot;</span>).keys())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(distilbert_tasks)
[<span class="hljs-string">&quot;default&quot;</span>, <span class="hljs-string">&quot;masked-lm&quot;</span>, <span class="hljs-string">&quot;causal-lm&quot;</span>, <span class="hljs-string">&quot;sequence-classification&quot;</span>, <span class="hljs-string">&quot;token-classification&quot;</span>, <span class="hljs-string">&quot;question-answering&quot;</span>]`}}),{c(){d=l("meta"),q=m(),c=l("h1"),O=l("a"),X=l("span"),g(v.$$.fragment),N=m(),P=l("span"),E=n("Export a model to ONNX with optimum.exporters.onnx"),K=m(),y=l("h2"),j=l("a"),I=l("span"),g(T.$$.fragment),re=m(),z=l("span"),Q=n("Summary"),f=m(),b=l("p"),Te=n("Exporting a model to ONNX is as simple as"),D=m(),g(M.$$.fragment),le=m(),Ae=l("p"),oo=n("Check out the help for more options:"),rt=m(),g(ie.$$.fragment),lt=m(),H=l("h2"),B=l("a"),Le=l("span"),g(pe.$$.fragment),so=m(),Ke=l("span"),ao=n("Why use ONNX?"),it=m(),V=l("p"),no=n(`If you need to deploy \u{1F917} Transformers or \u{1F917} Diffusers models in production environments, we recommend
exporting them to a serialized format that can be loaded and executed on specialized
runtimes and hardware. In this guide, we\u2019ll show you how to export these
models to `),me=l("a"),ro=n("ONNX (Open Neural Network eXchange)"),lo=n("."),pt=m(),U=l("p"),io=n(`ONNX is an open standard that defines a common set of operators and a common file format
to represent deep learning models in a wide variety of frameworks, including PyTorch and
TensorFlow. When a model is exported to the ONNX format, these operators are used to
construct a computational graph (often called an `),Qe=l("em"),po=n("intermediate representation"),mo=n(`) which
represents the flow of data through the neural network.`),mt=m(),Xe=l("p"),uo=n(`By exposing a graph with standardized operators and data types, ONNX makes it easy to
switch between frameworks. For example, a model trained in PyTorch can be exported to
ONNX format and then imported in TensorRT or OpenVino.`),ut=m(),g(W.$$.fragment),ht=m(),Pe=l("p"),ho=n(`\u{1F917} Optimum provides support for the ONNX export by leveraging configuration objects.
These configuration objects come ready made for a number of model architectures, and are
designed to be easily extendable to other architectures.`),dt=m(),qe=l("p"),ue=l("strong"),fo=n("To check the supported architectures, go to the "),je=l("a"),co=n("configuration reference page"),go=n("."),ft=m(),R=l("h2"),Y=l("a"),Be=l("span"),g(he.$$.fragment),_o=m(),Ve=l("span"),wo=n("Exporting a model to ONNX using the CLI"),ct=m(),Fe=l("p"),xo=n(`To export a \u{1F917} Transformers or \u{1F917} Diffusers model to ONNX, you\u2019ll first need to install some extra
dependencies:`),gt=m(),g(de.$$.fragment),_t=m(),De=l("p"),ko=n("The Optimum ONNX export can be used through Optimum command-line:"),wt=m(),g(fe.$$.fragment),xt=m(),Me=l("p"),$o=n("Exporting a checkpoint can be done as follows:"),kt=m(),g(ce.$$.fragment),$t=m(),Se=l("p"),vo=n("You should see the following logs (along with potential logs from PyTorch / TensorFlow that were hidden here for clarity):"),vt=m(),g(ge.$$.fragment),Nt=m(),G=l("p"),No=n("This exports an ONNX graph of the checkpoint defined by the "),Ue=l("code"),bo=n("--model"),Oo=n(` argument.
As you can see, the task was automatically detected. This was possible because the model was on the Hub.`),bt=m(),J=l("p"),yo=n("For local models, providing the "),We=l("code"),Eo=n("--task"),To=n(" argument is needed or it will default to the model architecture without any task specific head:"),Ot=m(),g(_e.$$.fragment),yt=m(),Z=l("p"),Ao=n("Note that providing the "),Ye=l("code"),Xo=n("--task"),Po=n(" argument for a model on the Hub will disable the automatic task detection."),Et=m(),A=l("p"),qo=n("The resulting "),Ge=l("code"),jo=n("model.onnx"),Fo=n(" file can then be run on one of the "),we=l("a"),Do=n(`many
accelerators`),Mo=n(` that support the ONNX
standard. For example, we can load and run the model with `),xe=l("a"),So=n(`ONNX
Runtime`),Co=n(" using the "),Je=l("code"),Io=n("optimum.onnxruntime"),zo=n(" package as follows:"),Tt=m(),g(ke.$$.fragment),At=m(),Ce=l("p"),Ho=n("Printing the outputs would give that:"),Xt=m(),g($e.$$.fragment),Pt=m(),Ie=l("p"),Ro=n("As you can see, converting a model to ONNX does not mean leaving the Hugging Face ecosystem. You end up with a similar API as regular \u{1F917} Transformers models!"),qt=m(),g(ee.$$.fragment),jt=m(),te=l("p"),Lo=n("The process is identical for TensorFlow checkpoints on the Hub. For example, we can export a pure TensorFlow checkpoint from the "),ve=l("a"),Ko=n(`Keras
organization`),Qo=n(" as follows:"),Ft=m(),g(Ne.$$.fragment),Dt=m(),L=l("h2"),oe=l("a"),Ze=l("span"),g(be.$$.fragment),Bo=m(),et=l("span"),Vo=n("Selecting a task"),Mt=m(),se=l("p"),Uo=n("Specifying a "),tt=l("code"),Wo=n("--task"),Yo=n(" should not be necessary in most cases when exporting from a model on the Hugging Face Hub."),St=m(),ae=l("p"),Go=n("However, in case you need to check for a given a model architecture what tasks the ONNX export supports, we got you covered. First, you can check the list of supported tasks for both PyTorch and TensorFlow "),ze=l("a"),Jo=n("here"),Zo=n("."),Ct=m(),ne=l("p"),es=n("For each model architecture, you can find the list of supported tasks via the "),He=l("a"),ts=n("TasksManager"),os=n(". For example, for DistilBERT, for the ONNX export, we have:"),It=m(),g(Oe.$$.fragment),zt=m(),S=l("p"),ss=n("You can then pass one of these tasks to the "),ot=l("code"),as=n("--task"),ns=n(" argument in the "),st=l("code"),rs=n("optimum-cli export onnx"),ls=n(" command, as mentioned above."),this.h()},l(e){const s=Zs('[data-svelte="svelte-1phssyn"]',document.head);d=i(s,"META",{name:!0,content:!0}),s.forEach(t),q=u(e),c=i(e,"H1",{class:!0});var ye=p(c);O=i(ye,"A",{id:!0,class:!0,href:!0});var at=p(O);X=i(at,"SPAN",{});var is=p(X);_(v.$$.fragment,is),is.forEach(t),at.forEach(t),N=u(ye),P=i(ye,"SPAN",{});var ps=p(P);E=r(ps,"Export a model to ONNX with optimum.exporters.onnx"),ps.forEach(t),ye.forEach(t),K=u(e),y=i(e,"H2",{class:!0});var Rt=p(y);j=i(Rt,"A",{id:!0,class:!0,href:!0});var ms=p(j);I=i(ms,"SPAN",{});var us=p(I);_(T.$$.fragment,us),us.forEach(t),ms.forEach(t),re=u(Rt),z=i(Rt,"SPAN",{});var hs=p(z);Q=r(hs,"Summary"),hs.forEach(t),Rt.forEach(t),f=u(e),b=i(e,"P",{});var ds=p(b);Te=r(ds,"Exporting a model to ONNX is as simple as"),ds.forEach(t),D=u(e),_(M.$$.fragment,e),le=u(e),Ae=i(e,"P",{});var fs=p(Ae);oo=r(fs,"Check out the help for more options:"),fs.forEach(t),rt=u(e),_(ie.$$.fragment,e),lt=u(e),H=i(e,"H2",{class:!0});var Lt=p(H);B=i(Lt,"A",{id:!0,class:!0,href:!0});var cs=p(B);Le=i(cs,"SPAN",{});var gs=p(Le);_(pe.$$.fragment,gs),gs.forEach(t),cs.forEach(t),so=u(Lt),Ke=i(Lt,"SPAN",{});var _s=p(Ke);ao=r(_s,"Why use ONNX?"),_s.forEach(t),Lt.forEach(t),it=u(e),V=i(e,"P",{});var Kt=p(V);no=r(Kt,`If you need to deploy \u{1F917} Transformers or \u{1F917} Diffusers models in production environments, we recommend
exporting them to a serialized format that can be loaded and executed on specialized
runtimes and hardware. In this guide, we\u2019ll show you how to export these
models to `),me=i(Kt,"A",{href:!0,rel:!0});var ws=p(me);ro=r(ws,"ONNX (Open Neural Network eXchange)"),ws.forEach(t),lo=r(Kt,"."),Kt.forEach(t),pt=u(e),U=i(e,"P",{});var Qt=p(U);io=r(Qt,`ONNX is an open standard that defines a common set of operators and a common file format
to represent deep learning models in a wide variety of frameworks, including PyTorch and
TensorFlow. When a model is exported to the ONNX format, these operators are used to
construct a computational graph (often called an `),Qe=i(Qt,"EM",{});var xs=p(Qe);po=r(xs,"intermediate representation"),xs.forEach(t),mo=r(Qt,`) which
represents the flow of data through the neural network.`),Qt.forEach(t),mt=u(e),Xe=i(e,"P",{});var ks=p(Xe);uo=r(ks,`By exposing a graph with standardized operators and data types, ONNX makes it easy to
switch between frameworks. For example, a model trained in PyTorch can be exported to
ONNX format and then imported in TensorRT or OpenVino.`),ks.forEach(t),ut=u(e),_(W.$$.fragment,e),ht=u(e),Pe=i(e,"P",{});var $s=p(Pe);ho=r($s,`\u{1F917} Optimum provides support for the ONNX export by leveraging configuration objects.
These configuration objects come ready made for a number of model architectures, and are
designed to be easily extendable to other architectures.`),$s.forEach(t),dt=u(e),qe=i(e,"P",{});var vs=p(qe);ue=i(vs,"STRONG",{});var Bt=p(ue);fo=r(Bt,"To check the supported architectures, go to the "),je=i(Bt,"A",{href:!0});var Ns=p(je);co=r(Ns,"configuration reference page"),Ns.forEach(t),go=r(Bt,"."),Bt.forEach(t),vs.forEach(t),ft=u(e),R=i(e,"H2",{class:!0});var Vt=p(R);Y=i(Vt,"A",{id:!0,class:!0,href:!0});var bs=p(Y);Be=i(bs,"SPAN",{});var Os=p(Be);_(he.$$.fragment,Os),Os.forEach(t),bs.forEach(t),_o=u(Vt),Ve=i(Vt,"SPAN",{});var ys=p(Ve);wo=r(ys,"Exporting a model to ONNX using the CLI"),ys.forEach(t),Vt.forEach(t),ct=u(e),Fe=i(e,"P",{});var Es=p(Fe);xo=r(Es,`To export a \u{1F917} Transformers or \u{1F917} Diffusers model to ONNX, you\u2019ll first need to install some extra
dependencies:`),Es.forEach(t),gt=u(e),_(de.$$.fragment,e),_t=u(e),De=i(e,"P",{});var Ts=p(De);ko=r(Ts,"The Optimum ONNX export can be used through Optimum command-line:"),Ts.forEach(t),wt=u(e),_(fe.$$.fragment,e),xt=u(e),Me=i(e,"P",{});var As=p(Me);$o=r(As,"Exporting a checkpoint can be done as follows:"),As.forEach(t),kt=u(e),_(ce.$$.fragment,e),$t=u(e),Se=i(e,"P",{});var Xs=p(Se);vo=r(Xs,"You should see the following logs (along with potential logs from PyTorch / TensorFlow that were hidden here for clarity):"),Xs.forEach(t),vt=u(e),_(ge.$$.fragment,e),Nt=u(e),G=i(e,"P",{});var Ut=p(G);No=r(Ut,"This exports an ONNX graph of the checkpoint defined by the "),Ue=i(Ut,"CODE",{});var Ps=p(Ue);bo=r(Ps,"--model"),Ps.forEach(t),Oo=r(Ut,` argument.
As you can see, the task was automatically detected. This was possible because the model was on the Hub.`),Ut.forEach(t),bt=u(e),J=i(e,"P",{});var Wt=p(J);yo=r(Wt,"For local models, providing the "),We=i(Wt,"CODE",{});var qs=p(We);Eo=r(qs,"--task"),qs.forEach(t),To=r(Wt," argument is needed or it will default to the model architecture without any task specific head:"),Wt.forEach(t),Ot=u(e),_(_e.$$.fragment,e),yt=u(e),Z=i(e,"P",{});var Yt=p(Z);Ao=r(Yt,"Note that providing the "),Ye=i(Yt,"CODE",{});var js=p(Ye);Xo=r(js,"--task"),js.forEach(t),Po=r(Yt," argument for a model on the Hub will disable the automatic task detection."),Yt.forEach(t),Et=u(e),A=i(e,"P",{});var C=p(A);qo=r(C,"The resulting "),Ge=i(C,"CODE",{});var Fs=p(Ge);jo=r(Fs,"model.onnx"),Fs.forEach(t),Fo=r(C," file can then be run on one of the "),we=i(C,"A",{href:!0,rel:!0});var Ds=p(we);Do=r(Ds,`many
accelerators`),Ds.forEach(t),Mo=r(C,` that support the ONNX
standard. For example, we can load and run the model with `),xe=i(C,"A",{href:!0,rel:!0});var Ms=p(xe);So=r(Ms,`ONNX
Runtime`),Ms.forEach(t),Co=r(C," using the "),Je=i(C,"CODE",{});var Ss=p(Je);Io=r(Ss,"optimum.onnxruntime"),Ss.forEach(t),zo=r(C," package as follows:"),C.forEach(t),Tt=u(e),_(ke.$$.fragment,e),At=u(e),Ce=i(e,"P",{});var Cs=p(Ce);Ho=r(Cs,"Printing the outputs would give that:"),Cs.forEach(t),Xt=u(e),_($e.$$.fragment,e),Pt=u(e),Ie=i(e,"P",{});var Is=p(Ie);Ro=r(Is,"As you can see, converting a model to ONNX does not mean leaving the Hugging Face ecosystem. You end up with a similar API as regular \u{1F917} Transformers models!"),Is.forEach(t),qt=u(e),_(ee.$$.fragment,e),jt=u(e),te=i(e,"P",{});var Gt=p(te);Lo=r(Gt,"The process is identical for TensorFlow checkpoints on the Hub. For example, we can export a pure TensorFlow checkpoint from the "),ve=i(Gt,"A",{href:!0,rel:!0});var zs=p(ve);Ko=r(zs,`Keras
organization`),zs.forEach(t),Qo=r(Gt," as follows:"),Gt.forEach(t),Ft=u(e),_(Ne.$$.fragment,e),Dt=u(e),L=i(e,"H2",{class:!0});var Jt=p(L);oe=i(Jt,"A",{id:!0,class:!0,href:!0});var Hs=p(oe);Ze=i(Hs,"SPAN",{});var Rs=p(Ze);_(be.$$.fragment,Rs),Rs.forEach(t),Hs.forEach(t),Bo=u(Jt),et=i(Jt,"SPAN",{});var Ls=p(et);Vo=r(Ls,"Selecting a task"),Ls.forEach(t),Jt.forEach(t),Mt=u(e),se=i(e,"P",{});var Zt=p(se);Uo=r(Zt,"Specifying a "),tt=i(Zt,"CODE",{});var Ks=p(tt);Wo=r(Ks,"--task"),Ks.forEach(t),Yo=r(Zt," should not be necessary in most cases when exporting from a model on the Hugging Face Hub."),Zt.forEach(t),St=u(e),ae=i(e,"P",{});var eo=p(ae);Go=r(eo,"However, in case you need to check for a given a model architecture what tasks the ONNX export supports, we got you covered. First, you can check the list of supported tasks for both PyTorch and TensorFlow "),ze=i(eo,"A",{href:!0});var Qs=p(ze);Jo=r(Qs,"here"),Qs.forEach(t),Zo=r(eo,"."),eo.forEach(t),Ct=u(e),ne=i(e,"P",{});var to=p(ne);es=r(to,"For each model architecture, you can find the list of supported tasks via the "),He=i(to,"A",{href:!0});var Bs=p(He);ts=r(Bs,"TasksManager"),Bs.forEach(t),os=r(to,". For example, for DistilBERT, for the ONNX export, we have:"),to.forEach(t),It=u(e),_(Oe.$$.fragment,e),zt=u(e),S=i(e,"P",{});var Re=p(S);ss=r(Re,"You can then pass one of these tasks to the "),ot=i(Re,"CODE",{});var Vs=p(ot);as=r(Vs,"--task"),Vs.forEach(t),ns=r(Re," argument in the "),st=i(Re,"CODE",{});var Us=p(st);rs=r(Us,"optimum-cli export onnx"),Us.forEach(t),ls=r(Re," command, as mentioned above."),Re.forEach(t),this.h()},h(){h(d,"name","hf:doc:metadata"),h(d,"content",JSON.stringify(na)),h(O,"id","export-a-model-to-onnx-with-optimumexportersonnx"),h(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(O,"href","#export-a-model-to-onnx-with-optimumexportersonnx"),h(c,"class","relative group"),h(j,"id","summary"),h(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(j,"href","#summary"),h(y,"class","relative group"),h(B,"id","why-use-onnx"),h(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(B,"href","#why-use-onnx"),h(H,"class","relative group"),h(me,"href","http://onnx.ai"),h(me,"rel","nofollow"),h(je,"href","../package_reference/configuration#supported-architectures"),h(Y,"id","exporting-a-model-to-onnx-using-the-cli"),h(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Y,"href","#exporting-a-model-to-onnx-using-the-cli"),h(R,"class","relative group"),h(we,"href","https://onnx.ai/supported-tools.html#deployModel"),h(we,"rel","nofollow"),h(xe,"href","https://onnxruntime.ai/"),h(xe,"rel","nofollow"),h(ve,"href","https://huggingface.co/keras-io"),h(ve,"rel","nofollow"),h(oe,"id","selecting-a-task"),h(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(oe,"href","#selecting-a-task"),h(L,"class","relative group"),h(ze,"href","/exporters/task_manager"),h(He,"href","/docs/optimum/main/en/exporters/task_manager#optimum.exporters.TasksManager")},m(e,s){o(document.head,d),a(e,q,s),a(e,c,s),o(c,O),o(O,X),w(v,X,null),o(c,N),o(c,P),o(P,E),a(e,K,s),a(e,y,s),o(y,j),o(j,I),w(T,I,null),o(y,re),o(y,z),o(z,Q),a(e,f,s),a(e,b,s),o(b,Te),a(e,D,s),w(M,e,s),a(e,le,s),a(e,Ae,s),o(Ae,oo),a(e,rt,s),w(ie,e,s),a(e,lt,s),a(e,H,s),o(H,B),o(B,Le),w(pe,Le,null),o(H,so),o(H,Ke),o(Ke,ao),a(e,it,s),a(e,V,s),o(V,no),o(V,me),o(me,ro),o(V,lo),a(e,pt,s),a(e,U,s),o(U,io),o(U,Qe),o(Qe,po),o(U,mo),a(e,mt,s),a(e,Xe,s),o(Xe,uo),a(e,ut,s),w(W,e,s),a(e,ht,s),a(e,Pe,s),o(Pe,ho),a(e,dt,s),a(e,qe,s),o(qe,ue),o(ue,fo),o(ue,je),o(je,co),o(ue,go),a(e,ft,s),a(e,R,s),o(R,Y),o(Y,Be),w(he,Be,null),o(R,_o),o(R,Ve),o(Ve,wo),a(e,ct,s),a(e,Fe,s),o(Fe,xo),a(e,gt,s),w(de,e,s),a(e,_t,s),a(e,De,s),o(De,ko),a(e,wt,s),w(fe,e,s),a(e,xt,s),a(e,Me,s),o(Me,$o),a(e,kt,s),w(ce,e,s),a(e,$t,s),a(e,Se,s),o(Se,vo),a(e,vt,s),w(ge,e,s),a(e,Nt,s),a(e,G,s),o(G,No),o(G,Ue),o(Ue,bo),o(G,Oo),a(e,bt,s),a(e,J,s),o(J,yo),o(J,We),o(We,Eo),o(J,To),a(e,Ot,s),w(_e,e,s),a(e,yt,s),a(e,Z,s),o(Z,Ao),o(Z,Ye),o(Ye,Xo),o(Z,Po),a(e,Et,s),a(e,A,s),o(A,qo),o(A,Ge),o(Ge,jo),o(A,Fo),o(A,we),o(we,Do),o(A,Mo),o(A,xe),o(xe,So),o(A,Co),o(A,Je),o(Je,Io),o(A,zo),a(e,Tt,s),w(ke,e,s),a(e,At,s),a(e,Ce,s),o(Ce,Ho),a(e,Xt,s),w($e,e,s),a(e,Pt,s),a(e,Ie,s),o(Ie,Ro),a(e,qt,s),w(ee,e,s),a(e,jt,s),a(e,te,s),o(te,Lo),o(te,ve),o(ve,Ko),o(te,Qo),a(e,Ft,s),w(Ne,e,s),a(e,Dt,s),a(e,L,s),o(L,oe),o(oe,Ze),w(be,Ze,null),o(L,Bo),o(L,et),o(et,Vo),a(e,Mt,s),a(e,se,s),o(se,Uo),o(se,tt),o(tt,Wo),o(se,Yo),a(e,St,s),a(e,ae,s),o(ae,Go),o(ae,ze),o(ze,Jo),o(ae,Zo),a(e,Ct,s),a(e,ne,s),o(ne,es),o(ne,He),o(He,ts),o(ne,os),a(e,It,s),w(Oe,e,s),a(e,zt,s),a(e,S,s),o(S,ss),o(S,ot),o(ot,as),o(S,ns),o(S,st),o(st,rs),o(S,ls),Ht=!0},p(e,[s]){const ye={};s&2&&(ye.$$scope={dirty:s,ctx:e}),W.$set(ye);const at={};s&2&&(at.$$scope={dirty:s,ctx:e}),ee.$set(at)},i(e){Ht||(x(v.$$.fragment,e),x(T.$$.fragment,e),x(M.$$.fragment,e),x(ie.$$.fragment,e),x(pe.$$.fragment,e),x(W.$$.fragment,e),x(he.$$.fragment,e),x(de.$$.fragment,e),x(fe.$$.fragment,e),x(ce.$$.fragment,e),x(ge.$$.fragment,e),x(_e.$$.fragment,e),x(ke.$$.fragment,e),x($e.$$.fragment,e),x(ee.$$.fragment,e),x(Ne.$$.fragment,e),x(be.$$.fragment,e),x(Oe.$$.fragment,e),Ht=!0)},o(e){k(v.$$.fragment,e),k(T.$$.fragment,e),k(M.$$.fragment,e),k(ie.$$.fragment,e),k(pe.$$.fragment,e),k(W.$$.fragment,e),k(he.$$.fragment,e),k(de.$$.fragment,e),k(fe.$$.fragment,e),k(ce.$$.fragment,e),k(ge.$$.fragment,e),k(_e.$$.fragment,e),k(ke.$$.fragment,e),k($e.$$.fragment,e),k(ee.$$.fragment,e),k(Ne.$$.fragment,e),k(be.$$.fragment,e),k(Oe.$$.fragment,e),Ht=!1},d(e){t(d),e&&t(q),e&&t(c),$(v),e&&t(K),e&&t(y),$(T),e&&t(f),e&&t(b),e&&t(D),$(M,e),e&&t(le),e&&t(Ae),e&&t(rt),$(ie,e),e&&t(lt),e&&t(H),$(pe),e&&t(it),e&&t(V),e&&t(pt),e&&t(U),e&&t(mt),e&&t(Xe),e&&t(ut),$(W,e),e&&t(ht),e&&t(Pe),e&&t(dt),e&&t(qe),e&&t(ft),e&&t(R),$(he),e&&t(ct),e&&t(Fe),e&&t(gt),$(de,e),e&&t(_t),e&&t(De),e&&t(wt),$(fe,e),e&&t(xt),e&&t(Me),e&&t(kt),$(ce,e),e&&t($t),e&&t(Se),e&&t(vt),$(ge,e),e&&t(Nt),e&&t(G),e&&t(bt),e&&t(J),e&&t(Ot),$(_e,e),e&&t(yt),e&&t(Z),e&&t(Et),e&&t(A),e&&t(Tt),$(ke,e),e&&t(At),e&&t(Ce),e&&t(Xt),$($e,e),e&&t(Pt),e&&t(Ie),e&&t(qt),$(ee,e),e&&t(jt),e&&t(te),e&&t(Ft),$(Ne,e),e&&t(Dt),e&&t(L),$(be),e&&t(Mt),e&&t(se),e&&t(St),e&&t(ae),e&&t(Ct),e&&t(ne),e&&t(It),$(Oe,e),e&&t(zt),e&&t(S)}}}const na={local:"export-a-model-to-onnx-with-optimumexportersonnx",sections:[{local:"summary",title:"Summary"},{local:"why-use-onnx",title:"Why use ONNX?"},{local:"exporting-a-model-to-onnx-using-the-cli",title:"Exporting a model to ONNX using the CLI"},{local:"selecting-a-task",title:"Selecting a task"}],title:"Export a model to ONNX with optimum.exporters.onnx"};function ra(Ee){return ea(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ua extends Ys{constructor(d){super();Gs(this,d,ra,aa,Js,{})}}export{ua as default,na as metadata};
